<!--
  ~ #%L
  ~ chvote-bo
  ~ %%
  ~ Copyright (C) 2016 - 2019 République et Canton de Genève
  ~ %%
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  ~ GNU General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  ~ #L%
  -->

<mat-card id="selectedElectoralAuthorityKeyEdit" [class.read-only]="readOnly" *ngIf="ready">
  <mat-card-header>
    <mat-card-title>{{'voting-period.selected-electoral-authority-key.edit.title' | translate}}</mat-card-title>
    <mat-card-subtitle *ngIf="!readOnly" fxLayout="row" fxLayoutAlign="space-between">
      <span>{{'voting-period.selected-electoral-authority-key.edit.subtitle' | translate}}</span>
      <span>{{'global.forms.fields.required' | translate}}</span>
    </mat-card-subtitle>
  </mat-card-header>
  <mat-card-content>
    <ng-container *ngIf="possibleKeys.length > 0 && !readOnly">

      <form [formGroup]="form" novalidate>
        <div fxLayout="row wrap" fxLayoutGap="25px">
          <mat-form-field fxFlex="50 0 200px">
            <mat-select formControlName="keyId"
                        placeholder="{{'voting-period.selected-electoral-authority-key.edit.form.fields.keyId.placeholder' | translate}}">
              <mat-option *ngFor="let key of possibleKeys" [value]="key.id">
                {{ key.label }}
              </mat-option>
            </mat-select>

            <mat-error>
              <default-errors [fieldName]="'keyId'" [form]="form"></default-errors>
            </mat-error>

          </mat-form-field>
        </div>
      </form>

      <key-view *ngIf="form.getRawValue().keyId" [key]="keyById(form.getRawValue().keyId)">
      </key-view>
    </ng-container>
    <ng-container *ngIf="readOnly">
      <key-view *ngIf="key!=null" [key]="key">
      </key-view>
    </ng-container>

    <div *ngIf="(!readOnly && possibleKeys.length == 0) || (readOnly && key == null )" class="error"
         id="no-electoral-authority-keys">
      {{'voting-period.selected-electoral-authority-key.edit.electoral-authority-keys-required' | translate}}
    </div>
  </mat-card-content>
  <mat-card-actions *ngIf="!readOnly && possibleKeys.length > 0">
    <div fxLayout fxLayoutAlign="end">
      <button mat-raised-button id="saveButton" color="primary"
              (click)="save()">{{'global.actions.save' | translate | uppercase}}
      </button>
    </div>
  </mat-card-actions>

</mat-card>
